<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>
<?xbl href="bindings.xml"?>
<html><head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>X-Smiles.org</title>

<link href="xsmiles_style.css" type="text/css" rel="stylesheet">
<link href="xsmiles_style.html" type="text/css" rel="stylesheet">
<style type="text/css">
					td.nav, table.nav, tr.nav,td.contentarea {vertical-align: top; border-width:0px;}
				</style><!--NOTE: THIS FILE IS AUTOMATICALLY GENERATED BY XSL, DO NOT EDIT BY HAND. EDIT FEATURES.XML INSTEAD AND RUN 'build.sh sitedoc--></head><body>
<img alt="X-SMILES.ORG" src="xsmiles.gif"><table class="nav">
<tbody><tr class="nav">
<td class="nav" style="vertical-align: top; width: 100pt;">
     <div id="navbar" class="navbar">
     <div>
     <p id="link-xsmiles" class="link">
      <a class="linkmain" href="index.html">X-Smiles</a>
     </p>
     <p id="link-objectives" class="link">
      <a class="linkmain" href="xsmiles_objectives.html">Objectives</a>
     </p>
     <p id="link-contributors" class="link">
      <a class="linkmain"  href="contributors.html">Contributors</a>
     </p>
     <p id="link-screenshots" class="link">
      <a class="linkmain" href="screenshots.html">Screenshots</a>
     </p>
     <p id="link-downloads" class="link">
      <a class="linkmain" href="download.html">Download</a>
     </p>
     <p id="link-documents" class="link">  
      <a class="linkmain">Documents</a>
      <a class="linksub1" href="xsmiles_features.html">Features</a> 
      <a class="linksub1" href="xsmiles_installation.html">Installation</a>
      <a class="linksub1" href="platforms.html">Platforms</a>
      <a class="linksub1" href="xsmiles_faq.html">FAQ</a>
      <a class="linksub1" href="xsmiles_test.html">Testimonials</a>
     </p>
     <p id="link-developers" class="link">
      <a class="linkmain">Developer Area</a>
      <a class="linksub1" href="participate.html">Participating</a>
      <a class="linksub1" href="techspec.html">Technical Spec</a>
      <a class="linksub1" href="xsmiles_compiling.html">How to compile</a>
      <a class="linksub1" href="xsmiles_future.html">Projects</a>
      <a class="linksub1" href="http://www.xsmiles.org/javadoc/index.html">Javadoc</a>
      <a class="linksub1" href="cvs.html">CVS access</a>
      <a class="linksub1" href="xsmiles_smil.html">SMIL package</a>
      <a class="linksub1" href="http://www.xsmiles.org/demo/demos.xhtml">Demos</a>
     </p>
     <p id="link-reading" class="link">
      <a class="linkmain">Reading</a>
      <a class="linksub1" href="presentations.html">Presentations</a>
      <a class="linksub1" href="publications.html">Publications</a>
     </p>
     <p id="link-feedback" class="link">
      <a class="linkmain">Feedback</a>
      <a class="linksub1" href="http://sourceforge.net/bugs/?group_id=18700"> Bugs</a>
      <a class="linksub1" href="xsmiles_lists.html">Mailing lists</a>
     </p>
    </div>
    </div>
</td><td class="contentarea">
<div class="contentarea">
<h1>Compiling X-Smiles</h1>
<h2>General</h2>
<p>X-Smiles can be compiled with any jdk 1.1 - 1.3 compatible java
compiler (*). The development team has succesfully used javac 1.1-1.3
from Sun and jikes 1.2 from IBM.</p>
<p>You can either pull down the developement tree from the <a href="http://www.xsmiles.org/cvs.html">CVS</a> or <a href="download.html">download</a>
and unpack both the bin and src packages to the same directory. Go to
the src directory and execute either build.bat or build.sh depending on
your platform. Build.sh can also be used in Windows with the CYGWIN
package.</p>
<p>We use the 'ant' build system from the Apache's Jakarta project.</p>
<p>The following ant build targets are supported:</p>
<pre>      X-Smiles Build instructions
      -------------------------------------------------------------

       available targets are:

         compile  --&gt; compiles the source code
         compile-debug  --&gt; compiles the source code with debug
         compile-jdk11  --&gt; compiles the source code for jdk11
         docbook      --&gt; generates the docbook documentation.  
         run      --&gt; run x-smiles
         jar      --&gt; generates the jar file
         jar-ipaq --&gt; generates jar file optimized for iPaq
         jar-smil --&gt; generates the SMIL jar file
         jar-teletext --&gt; generates the Teletext browser jar file
         jar-jxta --&gt; generates the Jaxta MLFC + libs jar file
         javadoc  --&gt; generates the API documentation (needs Java 1.2 or higher)
         pack-demo --&gt; generates the demo distributions (zip)
         pack-src --&gt; generates the source/doc distributions (zip)
         pack-bin --&gt; generates the binary distributions (zip)
         pack-installer --&gt; generates the installer exe on windows
         pack-all       --&gt; generates the binary, demo and source distributions
         clean    --&gt; cleans up all generated files and directories
         run-tests    --&gt; compiles and runs all the tests
         run-tests-html    --&gt; compiles and runs all the tests and generates html summary
         usage    --&gt; provides help on using the build tool (default)

       See comments inside the build.xml file for more details.
      -------------------------------------------------------------
    </pre>
<p>(*) The SVG MLFC cannot be compiled with java 1.1.</p>
<h2>Eclipse SDK</h2>
<ol>
<li>Download and install JDK 5.0 from <a href="http://java.sun.com/">http://java.sun.com/</a>
</li>
<li>Download and install JMF from <a href="http://java.sun.com/products/java-media/jmf/">http://java.sun.com/products/java-media/jmf/</a>
<br>
</li>
<li>Download latest Eclipse milestone (e.g. 3.1M4) from <a href="http://www.eclipse.org/">http://www.eclipse.org</a>.</li>
<li>Install Eclipse.<br>
</li>
<li>Start Eclipse. Create the Workspace directory to your home dir and not to eclipse installation dir. Go to workbench.<br>
</li>
<li>Set up cvs.tml.hut.fi <a href="http://www.xsmiles.org/cvs.html">CVS</a> . <ul>
<li>Window -&gt; Perspective -&gt; CVS repository</li>
<li>Add CVS repository</li>
<li>Host: cvs.tml.hut.fi</li>
<li>Repository path: /cvs</li>
<li>User: anonymous or your CVS user</li>
<li>Passwd: anonymous or your CVS passwd<br>
</li>
<li>Connection type: ext or extssh <ul>
<li>The "ext" connection method can be configured on the Team/CVS/EXT Connection Method preference page&lt;&gt;&nbsp;&nbsp;&nbsp;<br>
</li>
</ul>
</li>
</ul>
</li>
<li>Pull X-Smiles project from CVS: <ul>
<li>Open HEAD, go to "xsmiles"</li>
<li>Right-click and select: Check out as...</li>
<li>select "Check out as a new project configured using the new project wizard"</li>
<li>select "HEAD"</li>
<li>select "JAva project"</li>
<li>Project name: xsmiles</li>
<li>select "Create separate source and output folders"</li>
<li>Click "Finish", the project will be pulled from the CVS</li>
</ul>
</li>
<li>Configure/compile project <ul>
<li>After x-smiles has been downloaded from the CVS, open the java perspective</li>
<li>right click xsmiles, and select "Properties"</li>
<li>Source tab - add the xsmiles/src/xsmiles dir as a source dir</li>
<li>Source tab - select output folder to be xsmiles/build</li>
<li>Libraries - add all jar's from xsmiles/bin/lib and xsmiles/bin/lib/endorsed</li>
<li>Order tab: set xerces.jar, xml-apis.jar and xalan.jar on top, before the JDK classes<br>
</li>
<li>Click "ok" and eclipse will start building x-smiles</li>
<li>If you get errors about javax.media., open Properties again and add jmf.jar from your jmf installation to "Libraries" tab</li>
</ul>
</li>
<li>Run X-Smiles <ul>
<li>Create a new run profile</li>
<li>Select fi.hut.tml.xsmiles.gui.gui2.swing.KickStartSwing as the main class</li>
<li>select xsmiles/bin as the working directory</li>
<li>set VM option: "-Djava.endorsed.dirs=lib/endorsed "<br>
</li>
<li>Run X-SMiles</li>
</ul>
</li>
</ol>(Eclipse Instructions written by Mikko Honkala)<br> 
<h2>Forte 3.0 - Sun One Forte 4.0</h2>
<p>It is possible to build X-Smiles using Forte. Follow these steps:</p>
<ul>
<li>Open project manager and create a project called X-Smiles</li>
<li>Open filesystems tab and add:</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>X-Smiles src dir</li>
<li>X-Smiles build dir</li>
<li>Every Jar file from bin/lib</li>
</ul>
</li>
<li>Open Project Settings</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>Set target to xsmiles build directory for all compiler types</li>
</ul>
</li>
<li>Select all files that you dont want to compile (mlfc/signature,
mlfc/comm, mlfc/x3d, messaging/JMSMessaging) and open properties page
(right mouse) and set compilation to 'Do not compile'</li>
</ul>
<h2>Windows</h2>
<p align="left">TBD: There is a script 'build.bat' in the bin directory
of the X-Smiles installation. You must have the environment variable
JAVA_HOME set to point to your jdk home directory.</p>
<p align="left">Use 'build.bat usage' to view the possible build targets.</p>
<p align="left">For example 'build jar' will compile the whole source code and build the xsmiles.jar file.</p>
<p align="left">Any Java IDE could also be used to compile X-Smiles.&nbsp;</p>
<h2>Linux</h2>
<p>As with windows, with the exception that the ant start script is called 'build.sh'.</p>
<h2>Sending patches&nbsp;&nbsp;</h2>
<p>You are encouraged to send patches to the developers list. See <a href="http://www.netbeans.org/devhome/community/contrib-patches.html">this document</a> for information on how to create patches.</p>
<h2>Problems ?</h2>
<p>Please see <a href="xsmiles_faq.html">the FAQ</a> for common problems and solutions.&nbsp;</p>
<hr>
		  Copyright (c) 2000-2007 X-Smiles.org et.al.
	</div>
</td>
</tr>
</tbody></table>
</body></html>